#include <gccore.h>
#include <ogcsys.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gbcore/gb.h"
#include "sound.h"
#include "filer.h"
#include "screen.h"
#include "menu.h"
#include "pad.h"
#include "fatfs/tff.h"

static inline unsigned long long mftb(void)
{
	register u32 tbu, tbl, tmp;

	asm volatile(
		"0:\n\t"
		"mftbu %0\n\t"
		"mftb %1\n\t"
		"mftbu %2\n\t"
		"cmpw %0, %2\n\t"
		"bne- 0b"
		: "=r"(tbu), "=r"(tbl), "=r"(tmp)
		:
		: "cc");

	return (((u64)tbu)<<32) + tbl;
}

unsigned long long getusec()
{
	return mftb() / 60.766322;
}

void mainloop(void)
{
//	unsigned long long cur_time, next_time, prev_time=getusec();
	int line;
	int count=0;
	
	wavoutStart();
	
	for(;;) {
		for(line=0; line<154; line++)
			gb_run();
		/*
		for(;;){
			cur_time = getusec();
			if(cur_time - prev_time >= 16666){
				prev_time = cur_time;
				break;
			}
		}
		*/
		
		if(tvmode == VI_PAL)
			count++;
		if (count < 5){
			VIDEO_SetNextFramebuffer(xfb[pg_drawframe]);
			VIDEO_Flush();
			VIDEO_WaitVSync();
			pg_showframe ^= 1;
			pg_drawframe ^= 1;
			skip = 0;
		}
		else{
			skip = 1;
			count = 0;
		}
		
		if(bMenu){
			wavoutStop();
			rin_menu();
			wavoutStart();
			bMenu = 0;
		}
	}
}

int main ()
{
	screenInit();
	PAD_Init(); //game cube init pad....
	wavoutInit();
	configInit();

	mh_print(28, 30, "Push buttons 1 and 2 of your Wiimote.", COLOR_WHITE);
	initpad(); //wiimote init pad

	FATFS ffs;
	if(f_mount(0, &ffs) != FR_OK)
		return 0;
	
	DIR dir;
	if(f_opendir(&dir, "RINSAVE") == FR_NO_FILE)
		f_mkdir("RINSAVE");
	
	while(load_rom()<=0)
		;
	
	mainloop();
	
	return 0;
}
