#include <gccore.h>
#include <ogcsys.h>
#include "wiiuse/wiiuse.h"

//PADStatus pad[4];
u16 new_pad=0, old_pad=0, now_pad=0;
wiimote** myWiimote;

int readpadstateinmenu(void)
{
	static int n=0;
	u16 tmp = 0;	
	struct wiimote_t* wm = myWiimote[0];
	
	if (wm->exp.type == EXP_CLASSIC) 
	{/* classic controller */
		struct classic_ctrl_t* cc = (classic_ctrl_t*)&wm->exp.classic;

		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_A))
			tmp |= PAD_BUTTON_A;
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_X))
			tmp |= PAD_BUTTON_A;
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_B))
			tmp |= PAD_BUTTON_B;
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_Y))
			tmp |= PAD_BUTTON_B;
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_ZL))
			tmp |= PAD_TRIGGER_L; //menu
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_FULL_L))
			tmp |= PAD_TRIGGER_L; //menu
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_ZR))
			tmp |= PAD_TRIGGER_R;//width
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_FULL_R))
			tmp |= PAD_TRIGGER_R;//width
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_PLUS))
			tmp |= PAD_BUTTON_START;//start
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_MINUS))
			tmp |= PAD_TRIGGER_Z; //select

		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_DOWN))
			tmp |= PAD_BUTTON_DOWN;
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_UP))
			tmp |= PAD_BUTTON_UP;
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_RIGHT))
			tmp |= PAD_BUTTON_RIGHT;
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_LEFT))
			tmp |= PAD_BUTTON_LEFT;

	}
	else
	{/* only wiimote */
		//buttons A & B
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_TWO) )
			tmp |= PAD_BUTTON_A;
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_ONE) )
			tmp |= PAD_BUTTON_B;

		//buttons select & start
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_A) )
			tmp |= PAD_BUTTON_START;//start
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_MINUS) )
			tmp |= PAD_TRIGGER_Z; //select

		//menu & width
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_HOME) )
			tmp |= PAD_TRIGGER_L; //menu
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_B) )
			tmp |= PAD_TRIGGER_R;//width

		//directions
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_DOWN) )
			tmp |= PAD_BUTTON_RIGHT;
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_UP) )
			tmp |= PAD_BUTTON_LEFT;
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_RIGHT) )
			tmp |= PAD_BUTTON_UP;
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_LEFT) )
			tmp |= PAD_BUTTON_DOWN;
	}
	now_pad = tmp;
	new_pad = tmp & ~old_pad;
	if(old_pad==tmp){
		n++;
		if(n>=5){
			new_pad = tmp;
			n = 0;
		}
	}else{
		n=0;
		old_pad = tmp;
	}
	return new_pad;
}
int readpadstateingame(void)
{
	u16 state = 0;

	struct wiimote_t* wm = myWiimote[0];

	if (wm->exp.type == EXP_CLASSIC) 
	{/* classic controller */
		struct classic_ctrl_t* cc = (classic_ctrl_t*)&wm->exp.classic;

		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_A))
			state|=1; //button A
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_X))
			state|=1; //button A
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_B))
			state|=2; //button B
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_Y))
			state|=2; //button B
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_PLUS))
			state|=8; // button start
		if ( IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_MINUS))
			state|=4; // button select

		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_DOWN))
			state|=16; // down
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_UP))
			state|=32; // up
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_RIGHT))
			state|=128; // right
		if (IS_PRESSED(cc, CLASSIC_CTRL_BUTTON_LEFT))
			state|=64; // left

	}
	else
	{/* only wiimote */
		//buttons A & B
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_TWO) )
			state|=1; //button A
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_ONE) )
			state|=2; //button B

		//buttons select & start
		
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_MINUS) )
			state|=4; // button select
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_PLUS) )
			state|=8; // button start

		//directions
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_DOWN) )
			state|=128; // right
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_UP) )
			state|=64; // left
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_RIGHT) )
			state|=32; // up
		if (IS_PRESSED(wm, WIIMOTE_BUTTON_LEFT) )
			state|=16; // down
	}
	return state;
}

void wiimote_event(struct wiimote_t* wm, int event) 
{
	switch (event) {
		case WIIUSE_EVENT:
			readpadstateinmenu();
			break;
	}
}

void initpad(void)
{
	bte_init();
	bte_start();

	myWiimote =  wiiuse_init(4, wiimote_event);
	wiiuse_find(myWiimote, 4, 5);
	wiiuse_connect(myWiimote, 4);
	wiiuse_set_leds(myWiimote[0], WIIMOTE_LED_1);
	wiiuse_rumble(myWiimote[0], 1);
	usleep(500000);
	wiiuse_rumble(myWiimote[0], 0);
	wiiuse_set_ir(myWiimote[0], 0);
}
